From c5ffcde3277e3aec48f0f1f2689fd628b3972d2f Mon Sep 17 00:00:00 2001
From: oltolm <oleg.tolmatcev@gmail.com>
Date: Tue, 26 Dec 2023 14:42:39 +0100
Subject: [PATCH] ld: fix 32-bit mingw DLL symbol export bug

Signed-off-by: oltolm <oleg.tolmatcev@gmail.com>
---
 ld/deffilep.y | 5 ++---
 1 file changed, 2 insertions(+), 3 deletions(-)

diff --git a/ld/deffilep.y b/ld/deffilep.y
index 33c8cf35c5..45f90306e3 100644
--- a/ld/deffilep.y
+++ b/ld/deffilep.y
@@ -610,12 +610,11 @@ cmp_export_elem (const def_file_export *e, const char *ex_name,
 {
   int r;
 
-  if ((r = are_names_equal (ex_name, e->name)) != 0)
+  if ((r = are_names_equal (its_name ? its_name : ex_name,
+			    e->its_name ? e->its_name : e->name)) != 0)
     return r;
   if ((r = are_names_equal (in_name, e->internal_name)) != 0)
     return r;
-  if ((r = are_names_equal (its_name, e->its_name)) != 0)
-    return r;
   return (ord - e->ordinal);
 }
 
-- 
2.43.0.windows.1

